/* (C) Copyright 1984,85,86,87 Walter L. Peacock   All Rights Reserved    */
/*---------------------------------------------------------------------------- 
 * deletrec() is called to delete a data record or an index node and to 
 * return the deleted record to the free space chain.  It will use the first 
 * seven bytes of the deleted record to maintain the linked list.
 *---------------------------------------------------------------------------*/

#include "cbtree.h"

int deletrec(fd, recloc, reclen)
int fd;
long recloc;
unsigned reclen;
{
   extern void free();
   extern long lseek();
   BTBLKHDR freespcb;
   long int *lptr;
   char cbuff[3 * SZCHAR + sizeof(long)];
   register f, k;

   getfhdr(&freespcb, fd);

   f = k = 0;
   cbuff[f++] = '~';
   lptr = &freespcb.freelst;
   while(k < sizeof(long) )
      cbuff[f++] = ((char *)lptr)[k++];

   cbuff[f++] = '~';
   cbuff[f++] = '^';

   if (btseek(fd, recloc, reclen) == -1L)
      ckerror(- CK_SEEK, "1");
   if (write(fd, cbuff, (3 * sizeof(char) + sizeof(long) ) ) == ERR)
      ckerror(- CK_WRIT, "2");

   freespcb.freelst = recloc;
   putfhdr(fd, &freespcb);

   return(0);
}
